#include <stdio.h>
// fehlende header:
#include <stdlib.h>
#include <string.h>

#define LENGTH 256

char* copy_string(const char *string_to_copy);

// Rückgabewert muss int sein
int main () {
	// Variable wird nicht benutzt
	//int i = 0;

	char *src = "Hello World\n", *dst;
	// dst muss allokiert werden
	dst = (char*) malloc(strlen(src) + 1);

	char *new;

	// 1.) dst und src vertauscht
	// 2.) Das NULL byte muss ebenfalls kopiert werden
	strncpy(dst, src, strlen(src) + 1);

	new = copy_string(src);

	// hier darf der pointer nicht derefernziert werden
	printf("dst = %s\n", dst);


	printf("new = %s\n", new);

	// beide mallocs müssen allokiert werden
	free(new);
	free(dst);

	return 0;
}

// deklaration oben war const char as parameter
char* copy_string(const char *string_to_copy) {
	char* return_string = malloc(LENGTH);
	strncpy(return_string, string_to_copy, LENGTH - 1);
	return return_string; 
}
