
#include <stdio.h>
#include <stdlib.h>
// https://openbook.rheinwerk-verlag.de/c_von_a_bis_z/012_c_zeiger_010.htm
#define INPUT  0
#define OUTPUT 1

int main(int argc, char **argv) {
   int (*ptr[])(const char *, ...) = { scanf, printf };
   
   /*  Das waere falsch: 
    *  	int (*ptr[])(const char *, ...) = { scanf, printf, fgets }; 
    *  Signatur scanf():  int scanf( char const * formatString, ... )
    *  Signatur printf(): int scanf( char const * formatString, ... )
    *  aber
    *  Signatur fgets():  char * fgets( char * str, int size, FILE * stream )
    */ 
   
   int zahl;
   float zahlf;

   (*ptr[OUTPUT])("Bitte eine int Zahl eingeben: ");
   (*ptr[INPUT])("%d",&zahl);
   (*ptr[OUTPUT])("Die int Zahl lautet %d\n",zahl);
   
   (*ptr[OUTPUT])("Bitte eine float Zahl eingeben: ");
   (*ptr[INPUT])("%f",&zahlf);
   (*ptr[OUTPUT])("Die float Zahl lautet %f\n",zahlf);
   
   (*ptr[OUTPUT])("Der erste Parameter der Kommandzeile war: %s\n",argv[0]);
   return EXIT_SUCCESS;
}

