// C program to illustrate command line arguments
// clang-format -style=llvm -i- _8_main_params.c
#include <stdio.h>

int main(int argc, char *argv[]) {
  printf("Program name is: %s\n", argv[0]);

  if (argc == 1){
    printf("No Extra Command Line Argument Passed Other Than Program Name\n");
  }
  
  if (argc >= 2) {
    printf("Number Of Arguments Passed: %d\n", argc);
    printf("----Following Are The Command Line Arguments Passed---\n");
    for (int i = 0; i < argc; i++){
      printf("argv[%d]: %s\n", i, argv[i]);
    }
  }
  return 0;
}
