#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>

/*
 * Moegliche Probleme in dem Prozessenablauf
 */  

int main(int argc, char **argv){
    
    pid_t child;
    
    for(int i = 0; i<3; i++){
		if((child=fork())<0){
			printf("Problem with fork()!\n");
			exit(1);
		} else if (child == 0){
			printf("\t In child process, parentID=%d ", getppid());
			printf("\t childID=%d\n", getpid());	
		//	return 0;	
		} else {
			printf("In parent process, parentID=%d ", getppid());
			printf("myID=%d \n", getpid());
		}
	}
    
    /*
    // Auf Kindprozesse warten
    for (int i = 0; i < 3; i++) {
        int status;
        pid_t pid = wait(&status);
        if (pid == -1) { // Fehler beim Warten auf Kindprozess
            printf("Fehler: Warten auf Kindprozess fehlgeschlagen.\n");
            return -1;
        }
    }
    */

    return 0;   
}

/**
 * 	Drei Iterationen; in jeder ein Aufruf fork()
 *  Parent Context wird im Child vollkommen nachgebildet
 *  Wieviel Prozesse sind im Spiel?
 * 
 * 	                  pid1
 * 	         pid1                  pid2
 * 	    pid1      pid3        pid2      pid4
 *    pid1 pid5 pid3  pid6  pid2 pid7 pid4 pid8
 **/
