#include <unistd.h> 
#include <errno.h> 
#include <sys/types.h> 
#include <sys/wait.h> 
#include <stdio.h> 
#include <string.h>

int main(int argc, char** argv) {
	pid_t pid; 
	int status;
	pid = fork(); 
	if (pid == 0) {
		printf("Child: This is the child process!\n"); 
	} else if (pid > 0) {
        printf("Parent: This is the parent process!\n");
        printf("Parent: Waiting for child to terminate!\n");
        waitpid(pid, &status, 0);
        printf("Parent: Child has terminated!\n");
	} else {
		fprintf(stderr, "Error during fork: %s\n",
			strerror(errno));
	}
	return 0;
}
